/*

    Zelda Return of the Hylian

    Copyright (C) 2005-2008  Vincent Jouillat

    Please send bugreports with examples or suggestions to www.zeldaroth.fr

*/

#include <SDL/SDL.h>
#include <SDL_image/SDL_image.h>

#include "Texte.h"
#include "Menu.h"
#include "Joueur.h"
#include "Monde.h"
#include "Projectile.h"
#include "Jeu.h"

Texte::Texte(Jeu* jeu) : gpJeu(jeu), vitesse(40), av(0), x(0), y(0), w(0), h(0),
id(0), idsuiv(0), def(false), cadre(false), texte(""), buffer("") {
    lastAnimTime = SDL_GetTicks();
    imageFont = IMG_Load((getPath() + "/Contents/Resources/data/images/texte/font.png").c_str());
    SDL_SetColorKey(imageFont,SDL_SRCCOLORKEY,SDL_MapRGB(imageFont->format,0,0,255));
    imageCoeur = IMG_Load((getPath() + "/Contents/Resources/data/images/menu/coeur.png").c_str());
    SDL_SetColorKey(imageCoeur,SDL_SRCCOLORKEY,SDL_MapRGB(imageCoeur->format,0,0,255));
}

Texte::~Texte() {
    SDL_FreeSurface(imageFont);
    SDL_FreeSurface(imageCoeur);
}

void Texte::chercheText() {
    ostringstream os;
    int tmp;
    switch (id) {
        case 1  : texte = "Has encontrado un escudo !!!**Tu defensa aumenta de un punto!"; break;
        case 2  : texte = "Has encontrado una espada !!!**Ahora puedes defenderte contra los monstros con la tecla Z (o W) !!!*Manten Z para descargar el giratorio !"; break;
        case 3  : 
            tmp = 4-(gpJeu->getJoueur()->nbQuarts()%4);
            os << tmp;
            texte = "Has encontrado un cuarto de corazn !!!";
            if (tmp<4) buffer = "Con "+os.str()+" mas obtendras un corazn adicional !!!";
            else buffer = "Tu numero de coraznes acaba de aumentar !!!";
            break;
        case 11 : texte = "N : Casa de Link*O : Finca de Hyrule*E : Templo del Bosque"; break;
        case 12 : texte = "Templo de la Montaa**No aconsejado para cardiacos, miedosos, y emotivos en general."; break;
        case 13 : texte = "O : Entrada del desierto*N : Templo de la Montaa"; break;
        case 14 : texte = "N : Templo de la Montaa*S : Finca de Hyrule"; break;
        case 15 : texte = "N : Montaa de la Muerte"; break;
        case 16 : texte = "E : Entrada del Bosque"; break;
        case 17 : texte = "S : Lago de Hylia*E : Cementerio de los Espritus"; break;
        case 18 : texte = "S : Hacia el pueblo Kakariko"; break;
        case 19 : texte = "N : Pueblo Kakariko"; break;
        case 20 : texte = "N : Finca de Hyrule"; break;
        case 21 : texte = "O : Tierras de Fuego"; break;
        case 22 : texte = "E : Pueblo de la Sombra*- Prohibido a los seres vivos -"; break;
        case 23 : texte = "Templo de las tinieblas**Si eres un fantasma y que buscas un trabajo, ms bien vente a estar parado aqu."; break;
        case 24 : texte = "N : Pueblo de la Sombra*O : Lago de Hylia"; break;
        case 25 : texte = "N : Cementerio de los Espritus**Entrada prohibida"; break;
        case 26 : texte = "Pueblo de la Sombra"; break;
        case 27 : texte = "Vendo una botella por 100 rupias, quieres ?*              SI ?            no  "; 
            if ((gpJeu->getJoueur()->hasBouteille(0) && gpJeu->getZone()==8)
            || (gpJeu->getJoueur()->hasBouteille(1) && gpJeu->getZone()==5)
            || (gpJeu->getJoueur()->hasBouteille(2) && gpJeu->getZone()==6)) {id=32; chercheText();break;}
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<100) idsuiv=29;
            else idsuiv=30;
            break;
        case 28 : texte = "Vendo una botella por 100 rupias, quieres ?*              si              NO ?"; idsuiv=31; break;
        case 29 : texte = "Lo siento, pero no tienes bastantes rupias."; break;
        case 30 : texte = "Muchas gracias, he aqu tu botella."; break;
        case 31 : texte = "Vuelve si cambias de opinin."; break;
        case 32 : texte = "Lo siento, no tengo ms botellas."; break;
        case 33 : texte = "Has encontrado una botella vaca !!!**Podrs utilizarla para almacenar pozimas !!!"; break;
        case 35 : texte = "Los habitantes de este pueblo tienen un dialecto muy especial, no entiendo nada..."; break;
        case 36 : texte = "@+@+@+@+@+@+@@@+*@=++=@=+@=+@=+=@*+@+@+@+=+="; break;
        case 37 : texte = "Obten una autorization del jefe si quieres pasar de verdad !!!"; break;
        case 38 : texte = "El jefe te autoriz ??? Grrrr... Pues apartate!!!"; break;
        case 39 : texte = "Fuera de aqu !!!"; break;
        case 40 : texte = "No solemos ver muchos visitantes por aqu..."; break;
        case 41 : texte = "Los monstruos de aqu no temen muchas cosas, por suerte atacan solo los humanos."; break;
        case 42 : texte = "De verdad ?*Entiendes lo que digo ?"; break;
        case 43 : texte = "N : Desierto y Pueblo Gerudo"; break;
        case 44 : texte = "S : Lago de Hylia*O : Castillo de Hyrule"; break;
        case 45 : texte = "Pueblo Kakariko"; break;
        case 46 : texte = "O : Castillo de Hyrule"; break;
        case 47 : texte = "Que da tan bueno !!!"; break;
        case 48 : texte = "Pero porque acept cuidar estos bichos ???*Odio las gallinas !!!"; break;
        case 49 : texte = "Se encuentran muchas cosas en las tiendas de este pueblo."; break;
        case 50 : texte = "S : Pueblo Kakariko*O : Desierto*E : Montaa de la Muerte"; break;
        case 51 : texte = "Pueblo Gerudo"; break;
        case 52 : texte = "Perdido en el desierto ?*Estas aqu :*                        X"; break;
        case 54 : texte = "S : Hacia el Castillo de Hyrule"; break;
        case 55 : texte = "Templo del Desierto**Ven a probar nuestros baos.*(agua no potable)"; break;
        case 56 : texte = "Templo del Bosque**Salve los rboles, coma castor!!!"; break;
        case 57 : texte = "Templo del Lago**Gorro de bao obligatorio."; break;
        case 58 : texte = "Templo de Hielo**El personal insiste en recordar que un calabozo no es una pista de patinaje."; break;
        case 59 : texte = "Has visto el herrero del pueblo ?*Dicen que es muy avispado para mejorar el equipo de los aventureros, mucha gente le visita."; break;
        case 60 : texte = "El templo esta en el fondo del desierto, en puesto de una antigua oasis."; break;
        case 61 : texte = "S : Tierras de Fuego*E : Pueblo Kakariko"; break;
        case 62 : texte = "Castillo de Hyrule"; break;
        case 63 : texte = "E : Pueblo Kakariko"; break;
        case 64 : texte = "O : Tortuga de Roca*E : Lago de Hylia"; break;
        case 65 : texte = "Templo Oculto**Aqu descansa la Espada del Golpe Contra el Mal, la Espada Maestra."; break;
        case 66 : texte = "N : Hacia el Cimenterio encantado"; break;
        case 67 : texte = "Has encontrado el mapa del calabozo !!!*Pulsa P para verlo."; break;
        case 68 : texte = "Has encontrado la brjula !!!*Puedes localizar el jefe y las arcas sobre el mapa."; break;
        case 69 : texte = "Has encontrado la llave del jefe !!!"; break;
        case 70 : texte = "Has encontrado una llave pequea !!!*Acercate de una puerta para abrirla."; break;
        case 71 : texte = "Has encontrado los Guantes !!!*Utilizalos para levantar objetos equipandolos o pulsando C."; break;
        case 72 : 
            texte = "Has encontrado un cristal magico !!!"; 
            tmp = 7-gpJeu->getJoueur()->nbCristaux();
            os << tmp;
            if (tmp==6 && !gpJeu->getJoueur()->getAvancement()) buffer = "Cmo podra ser til... ?";
            else if (tmp>2) buffer = "Te quedan an "+os.str()+" por encontrar !!!";
            else if (tmp==2) buffer = "Solo 2 que encontrar !!!";
            else if (tmp==1) buffer = "Te falta solo uno !!!";
            else if (tmp==0) buffer = "Tienes todo los cristales, corre hasta el castillo a salvar a Zelda !!!";
            break;
        case 80 : texte = "Has encontrado el lanzagarfios !!! *Utilizalo para atravesar obstculos."; break;
        case 81 : texte = "Has encontrado la lampara !!! *Utilizala para hacer surgir llamas."; break;
        case 82 : texte = "Has encontrado las aletas !!! *Equipalas para ir en el agua."; break;
        case 83 : texte = "Has encontrado el martillo mgico !!! *Utilizalo para hundir obstculos."; break;
        case 84 : texte = "Has encontrado la varilla de fuego !!! *De ahora en adelante puedes lanzar potentes llamas remotas"; break;
        case 85 : texte = "Has encontrado la varilla de hielo !!! *Utilizala para congelar todo a distancia."; break;
        case 86 : texte = "Has encontrado la Espada Maestra !!! *Incluso Ganon no debera ser capaz de resistir a su potencia !!! (en teora)"; break;
        case 87 : texte = "Felicitaciones Link, has conseguido venir a liberarme!!!***Vamonos de prisa a encontrar a Ganon, tenemos que retomar la Trifuerza a toda costa !"; break;
        case 89 : texte = "El paso secreto detrs de la sala del trono lleva a Ganon. Vamos rapido !"; break;
        case 90 : texte = "Casi hemos llegado, sigueme !"; break;
        case 91 : texte = "Tengo miedo que no puedas nunca vencer a Ganon con tus armas actuales...*Ve a hablar con el jefe del pueblo Kakariko, estoy segura que l va a encontrar una solucin."; break;
        case 92 : texte = "Ganon esta ya detrs de esta puerta, voy a curarte las heridas."; break;
        case 93 : texte = "Ganon todava esta en algn sitio del castillo."; break;
        case 94 : texte = "Tendras que esperar a la princesa Zelda !!!"; break;
        case 95 : texte = "No tienes la extraa impresin de olvidar a alguien por casualidad ???"; break;
        case 96 : texte = "Zelda te esta esperando!!!"; break;
        case 97 : texte = "Has encontrado la Trifuerza!!!"; break;
        case 98 : texte = "Has encontrado el libro de Mudora!!! **Ahora entiendes el hyliano antiguo!!!"; break;
        case 99 : texte = "Felicitaciones Link, has conseguido encontrarme. En recompensa, te ofrezco el pendiente de Din, aumenta tu defensa de un punto."; break;
        case 100 : texte = "Felicitaciones Link, has conseguido encontrarme. En recompensa, te ofrezco el pendiente de Nayru, aumenta tu defensa de dos puntos!!!"; break;
        case 101 : texte = "..."; break;
        case 102 : texte = "Has obtenido un pendiente mgico !!!**Tu defensa acaba de aumentar!!!"; break;
        case 103 : texte = "Felicitaciones Link, has conseguido encontrarme. Para recompensarte, voy a doblar la capacidad de tu reserva de magia!!!"; break;
        case 104 : texte = "Tu reserva de magia ha doblado!!!"; break;
        case 105 : texte = "Vuelve cuando tengas una botella vaca  y te vender una pozima roja que te devuelve la energia."; break;
        case 106 : texte = "Una pozima roja por 60 rupias, la quieres ?*              SI ?            no  "; 
            if (gpJeu->getJoueur()->hasBouteille(0)!=1
            && gpJeu->getJoueur()->hasBouteille(1)!=1
            && gpJeu->getJoueur()->hasBouteille(2)!=1) {id=105; chercheText();break;}
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<60) idsuiv=29;
            else idsuiv=108; break;
        case 107 : texte = "Una pozima roja para 60 rupias, la quieres ?*              si              NO ?"; break;
        case 108 : texte = "Gracias, toma tu pozima.";break;
        case 109 : texte = "Has obtenido una pozima roja !!!*Bebela para renovar tu energia!!!"; break;
        case 110 : texte = "Has obtenido una pozima verde !!!*Bebela para renovar tu magia!!!"; break;
        case 111 : texte = "Has obtenido una pozima azul !!!*Bebela para renovar tu energia y tu magia!!!"; break;
        case 112 : texte = "Ola, en que puedo ayudarle ?"; break;
        case 113 : texte = "Hic! Dicen que una hada dara objetos encantados... Hic! ...a los aventureros que la encuentran... Hic!!!"; break;
        case 114 : texte = "Un corazn por 10 rupias, vale ?**              SI ?            no  "; 
            if (gpJeu->getJoueur()->getVie()+gpJeu->getJoueur()->getBoostVie()
            == gpJeu->getJoueur()->getVieMax()) {id=128; chercheText();break;}
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<10) idsuiv=29;
            else idsuiv=129; break;
        case 115 : texte = "Un corazn por 10 rupias, vale ?**             si              NO ?"; break;
        case 116 : texte = "Un poco de magia por 20 rupias, vale ?**              SI ?            no  "; 
            if (gpJeu->getJoueur()->getMagie()+gpJeu->getJoueur()->getBoostMagie()
            == gpJeu->getJoueur()->getMagieMax() || !gpJeu->getJoueur()->hasObjet(O_LANTERNE)) {
                id=128; chercheText();break;}
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<20) idsuiv=29;
            else idsuiv=129; break;
        case 117 : texte = "Un poco de magia por 20 rupias, vale ?**              si              NO ?"; break;
        case 118 : texte = "Mucho magia por 30 rupias, vale ?**              SI ?            no  "; 
            if (gpJeu->getJoueur()->getMagie()+gpJeu->getJoueur()->getBoostMagie()
            == gpJeu->getJoueur()->getMagieMax() || !gpJeu->getJoueur()->hasObjet(O_LANTERNE)) {
                id=128; chercheText();break;}
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<30) idsuiv=29;
            else idsuiv=129; break;
        case 119 : texte = "Mucho magia por 30 rupias, vale ?**              si              NO ?"; break;
        case 120 : texte = "5 flechas por 30 rupias, vale ?**              SI ?            no  "; 
            if (gpJeu->getJoueur()->getFleche() == gpJeu->getJoueur()->getFlecheMax() 
            || !gpJeu->getJoueur()->hasObjet(O_ARC)) {id=128; chercheText();break;}
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<30) idsuiv=29;
            else idsuiv=129; break;
        case 121 : texte = "5 flechas por 30 rupias, vale ?**              si              NO ?"; break;
        case 122 : texte = "Una bomba por 30 rupias, vale ?**              SI ?            no  "; 
            if (gpJeu->getJoueur()->getBombe() == gpJeu->getJoueur()->getBombeMax() 
            || !gpJeu->getJoueur()->hasObjet(O_SAC_BOMBES)) {id=128; chercheText();break;}
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<30) idsuiv=29;
            else idsuiv=129; break;
        case 123 : texte = "Una bomba por 30 rupias, vale ?**              si              NO ?"; break;
        case 124 : texte = "Un arco por 1000 rupias, vale ?**              SI ?            no  "; 
            idsuiv=29; break;
        case 125 : texte = "Un arco por 1000 rupias, vale ?**              si              NO ?"; break;
        case 126 : texte = "Un arco por 50 rupias, vale ?**              SI ?            no  "; 
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<50) idsuiv=29;
            else idsuiv=129; break;
        case 127 : texte = "Un arco por 50 rupias, vale ?**              si              NO ?"; break;
        case 128 : texte = "No necesitas eso ahora."; break;
        case 129 : texte = "Gracias."; break;
        case 130 : texte = "Has obtenido el arco !!!*Utilizalo para alcanzar objetivos alejados."; break;
        case 131 : texte = "Elige lo que quieras."; break;
        case 132 : texte = "Que ???*Estas en contratado por el jefe ???*Pues vale, te hago une reduccin sobre el arco..."; break;
        case 133 : texte = "Buenos das Link, soy el jefe de este pueblo, me figuraba que vendris."; idsuiv=134; break;
        case 134 : texte = "Desde esta maana monstruos aparecen en muchas partes de Hyrule, he intentado ir a hablar de eso con la princesa Zelda, pero como quizs ya lo has notado, un poderoso hechizo bloquea el acceso al castillo..."; idsuiv=136; break;
        case 136 : texte = "Dices que Ganon es responsable de todo esto ? Que ha robado la Trifuerza y que encarcela la princesa Zelda en el castillo ?"; idsuiv=137; break;
        case 137 : texte = "Pues... la situacin es mucho ms grave que lo que crea..."; idsuiv=138; break;
        case 138 : texte = "Tenemos que obrar rapidamente, debes enfrentar a Ganon de nuevo!"; idsuiv=139; break;
        case 139 : texte = "Cmo entrar en el castillo ? Quizs tenga una idea..."; idsuiv=140; break;
        case 140 : texte = "Como lo sabes, el poder de los 7 Hombres Sabios fue encerrado en 7 cristales por el mago Aghanim mientras intentaba quitar el hechizo que confinaba Ganon en el Dark World."; idsuiv=141; break;
        case 141 : texte = "Ahora bien, aunque resucitaste las descendientes de los hombres sabios despues de vencer a Ganon y de encontrar la Trifuerza, estos cristales conservaron sus potencia."; idsuiv=142; break;
        case 142 : texte = "Estan escondidos en los 7 templos, renelos todos y podrs ir ms all del sortilego de Ganon."; idsuiv=143; break;
        case 143 : texte = "Sin embargo, ser una tarea muy dura, Ganon sin duda ha debido de enviar sus mejores unidades a proteger esos cristales..."; idsuiv=144; break;
        case 144 : texte = "Una ultima cosa, no irs muy lejos con tu equipo actual. Ve a ver al vendedor de armas y dile que vienes de mi parte. Seguro que tu ayudar."; break;
        case 145 : texte = "Ve a ver el vendedor de armas y dile que vienes de mi parte. Seguro que tu ayudar."; break;
        case 146 : texte = "Tienes que reunir los 7 cristales si quieres tener una posibilidad de salvar a Zelda y Hyrule..."; break;
        case 147 : texte = "Has encontrado los 7 cristales ?  Ve al castillo, primero debes liberar a la princesa, ella sabr mejor que yo cmo salvar Hyrule."; break;
        case 148 : texte = "Tus armas no tienen efecto sobre Ganon ? En este caso tienes que encontrar la Espada Maestra. Se dice que fue disimulada en un templo secreto.*Se dice tambien que el camino que conduce a la Espada del Golpe Contra el Mal pasa por un pueblo lleno de monstros...*Me pregunto si tal pueblo existe..."; break;
        case 150 : texte = "No obstante tengo miedo que tu equipo actual sea insuficiente para acceder a este templo, a lo mejor deberas ir a ver al herrero del pueblo Gerudo..."; break;
        case 151 : texte = "Ya es hora de enfrentarse a Ganon y de recuperar la Trifuerza!"; break;
        case 152 : texte = "Hey! Hay que pagar para abrir una de mis arcas!!!"; break;
        case 153 : texte = "Una de estas arcas contiene un cuarto de corazn, quieres probar tu fortuna por 10 rupias ? Podrs abrir solo una, vale ?*              SI ?            no  "; 
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<10) idsuiv=29; break;
        case 154 : texte = "Una de estas arcas contiene un cuarto de corazn, quieres probar tu fortuna por 10 rupias ? Podrs abrir solo una, vale ?*              si              NO ?"; break;
        case 155 : texte = "Elige un arca."; break;
        case 156 : texte = "No tengo ms premios que poner en juego, lo siento."; break;
        case 157 : texte = "Has perdido! Este arca esta vaca."; break;
        case 158 : texte = "Buenos das! Si estas aqu para ver el herrero, vive un poco ms lejos."; break;
        case 159 : texte = "Ola Link, soy el jefe de este pueblo.*Deberas ir a ver el herrero y monstrarle lo que quieres que mejore en tu equipo.";
            buffer = "He sido informado de tu bsqueda, entonces me puse de acuerdo con el.*Todo ser gratis para ti."; break;
        case 160 : texte = "No necesitas beber esta pozima ahora."; break;
        case 161 : texte = "Una pozima verde por 40 rupias, la quieres ?*              SI ?            no  "; 
            if (gpJeu->getJoueur()->hasBouteille(0)!=1
            && gpJeu->getJoueur()->hasBouteille(1)!=1
            && gpJeu->getJoueur()->hasBouteille(2)!=1) {id=163; chercheText();break;}
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<40) idsuiv=29;
            else idsuiv=108; break;
        case 162 : texte = "Una pozima verde por 40 rupias, la quieres ?*              si              NO ?"; break;
        case 163 : texte = "Vuelve cuando tengas una botella vaca y te vender una pozima verde que rellena la magia."; break;
        case 164 : texte = "Vuelve ms tarde, estoy agobiado!"; break;
        case 165 : texte = "Puedo hacer algo para ti ?";
            if (gpJeu->getJoueur()->getEpee()==1) {id=166; chercheText();break;}
            if (gpJeu->getJoueur()->hasObjet(O_GANTS)==1 && gpJeu->getJoueur()->getObjet()==8) {
                id=169; chercheText();break;}
            if (gpJeu->getJoueur()->hasObjet(O_ARC)==2 && gpJeu->getJoueur()->getObjet()==0 
            && gpJeu->getJoueur()->nbCristaux()==7) {
                id=172; chercheText();break;}
            break;
        case 166 : texte = "Quieres que mejore tu espada ?**              SI ?            no  "; break;
        case 167 : texte = "Quieres que mejore tu espada ?**              si              NO ?"; break;
        case 168 : texte = "Tu espada ha triplicado de potencia y puede ahora devolver algunos ataques magicos, guay!!!"; break;
        case 169 : texte = "Quieres que mejore tus guantes ?**              SI ?            no  "; break;
        case 170 : texte = "Quieres que mejore tus guantes ?**              si              NO ?"; break;
        case 171 : texte = "La potencia de tus guantes te permite ahora levantar rocas pesadas."; break;
        case 172 : texte = "Quieres que mejore tu arco ?**              SI ?            no  "; break;
        case 173 : texte = "Quieres que mejore tu arco ?**              si              NO ?"; break;
        case 174 : texte = "Tu arco tira ahora flechas de plata de una potencia devastadora !!!"; break;
        case 175 : texte = "Vuelve cuando tengas una botella vaca y te vender una pozima azul que rellena la energia y la magia."; break;
        case 176 : texte = "Una pozima azul por 160 rupias, la quieres ?*              SI ?            no  "; 
            if (gpJeu->getJoueur()->hasBouteille(0)!=1
            && gpJeu->getJoueur()->hasBouteille(1)!=1
            && gpJeu->getJoueur()->hasBouteille(2)!=1) {id=175; chercheText();break;}
            if (gpJeu->getJoueur()->getRubis() + gpJeu->getJoueur()->getBoostRubis()<160) idsuiv=29;
            else idsuiv=108; break;
        case 177 : texte = "Una pozima azul por 160 rupias, la quieres ?*              si              NO ?"; break;
        case 178 : texte = "Nuestro pueblo fue fundado para impedir a los aventureros imprudentes que tengan acceso al templo, no da el permiso para pasar a cualquiera."; break;
        case 179 : texte = "Mmmm... Ya has encontrado 4 cristales ?*Tengo que confesar que me impresionas...";
            buffer = "Pues entendido, tienes el permiso para pasar por el cementerio, por tu cuenta y riesgo."; break;
        case 181 : texte = "Ve a hablar al guardia al norte del pueblo, te dejar pasar."; break;
        case 182 : texte = "Veo que siempre estas vivo...*Sorprendente."; break;
        case 183 : texte = "El templo de las tinieblas es el punto de partida del camino que conduce a un objeto de leyenda. Este pueblo solo sirve para disuadir a los aventureros de acercarse demasiado."; break;
        case 184 : texte = "Has encontrado la Espada ?*Pero no creas que es tuya por eso.";
            buffer = "La Espada Maestra forma parte del patrimonio el ms valioso de Hyrule con la Trifuerza, tendrs que devolverla en su santuario en cuanto acabes tu misin."; break;
        case 186 : texte = "Los habitantes de este pueblo son todos espritus que han contestado a la llamada de la princesa Zelda."; break;
        case 187 : texte = "Cuando devolviste la paz sobre Hyrule y reunificaste el Light World con el Golden Land, Zelda pregunt en secreto a los espritus voluntarios que crean este pueblo para bloquear";
            buffer = "el acceso a un objeto muy valioso."; break;
        
        case 189 : texte = "Bienvenido Link!*Dejame explicarte lo que hago aqu."; idsuiv=190; break;
        case 190 : texte = "Como ya lo has notado sin duda, monstruos han aparecido por todas partes en Hyrule. Es la primera vez que veo monstruos despues que venciste a Ganon."; idsuiv=191; break;
        case 191 : texte = "Pues he decidido catalogarlos todos."; idsuiv=192; break;
        case 192 : texte = "El problema es que soy demasiado miedoso para ir al encuentro de ellos, necesito tu ayuda."; idsuiv=193; break;
        case 193 : texte = "Tienes que golpear cada tipo de monstruo y venir a hacerme tu informe."; idsuiv=194; break;
        case 194 : texte = "Te recompensar cada vez que mates 7 nuevos tipos de enemigo."; idsuiv=195; break;
        case 195 : texte = "Si quieres ver que enemigos ya has vencido, pulsa M."; break;
        
        
        case 196 : 
            if (gpJeu->getJoueur()->getCoeur(43)) {
                if (gpJeu->getJoueur()->nbEnnemis() >= 46) {id=205; chercheText();return;}
                else {id=204; chercheText();return;}
            }
            for (int i = 38; i < 44; i++) 
                if (!gpJeu->getJoueur()->getCoeur(i) 
                && (gpJeu->getJoueur()->nbEnnemis()/7)+37>=i) {
                    id=203; chercheText();return;
                }
            tmp = 7-(gpJeu->getJoueur()->nbEnnemis()%7);
            os << tmp;
            if (tmp>1) texte = "Con "+os.str()+" mas enemigos diferentes tendras la proxima recompensa.";
            else texte = "Te falta solo uno nuevo enemigo antes de la proxima recompensa!!!";
            break;
        case 203 : texte = "Acepta este regalo por tu contribucin en mi proyecto :"; break;
        case 204 : texte = "Lo siento pero no tengo nada ms que regalarte..."; break;
        case 205 : texte = "No me le puedo creer, has conseguido vencer cada tipo de enemigo !!!*Felicitaciones Link !!!"; break;
        
        case 206 : texte = "                    Nivel 1 :**               Templo del Bosque"; break;
        case 207 : texte = "                    Nivel 2 :**                Templo del Agua"; break;
        case 208 : texte = "                    Nivel 3 :**              Templo de la Montaa"; break;
        case 209 : texte = "                    Nivel 4 :**              Templo del Desierto"; break;
        case 210 : texte = "                    Nivel 5 :**            Templo de las Tinieblas"; break;
        case 211 : texte = "                    Nivel 6 :**                Templo del Fuego"; break;
        case 212 : texte = "                    Nivel 7 :**                Templo de Hielo"; break;
        case 213 : texte = "                    Nivel ? :**                 Templo Oscuro"; break;
        case 214 : texte = "                  Nivel Final :**               Castillo de Hyrule"; break;
        
        case 215 :texte = "               Ya estas cansado ?               ?                   SEGUIR                  ?                  Grabar y dejar                                Dejar sin grabar              "; break;
        case 216 :texte = "               Ya estas cansado ?                                   Seguir                     ?               GRABAR Y DEJAR              ?                 Dejar sin grabar              "; break;
        case 217 :texte = "               Ya estas cansado ?                                   Seguir                                     Grabar y dejar                 ?              DEJAR SIN GRABAR             ?"; break;
        
        case 223 : texte = "En el momento en que Link toc la Trifuerza, los monstruos desaparecieron y la paz volvi.**La princesa Zelda tom entonces una gran decisin: toc a su vez la Trifuerza para formular su deseo...**La Trifuerza siempre fue el origen de los problemas sobrevenidos en el Reino,  tarde o temprano una otra criatura daina habra acabado encontrandola.**Al mismo tiempo que la princesa toc la reliquia, desapareci para siempre de Hyrule.";
            buffer = "Desde ese da, el pueblo de Hyrule vivi en paz, sin temer nuevos desastres.**Asi se acaba la leyenda de Zelda, de la  Trifuerza y del Golden Land.**Se dice que la Espada Maestra descansa en seguridad en cualquier lugar, y que es el ultimo recuerdo de la bsqueda de Link..."; break;
        case 224 : texte = "Felicitaciones Link, has conseguido encontrarme. En recompensa, te ofrezco el pendiente de Farore, aumenta tu defensa de un punto."; break;
        case 225 : texte = "Quieres grabar tu juego ?**                      ? SI ?*                        no  "; break;
        case 226 : texte = "Quieres grabar tu juego ?**                        si  *                      ? NO ?"; break;
        case 227 : texte = "Juego grabado."; break;
        
        case 228 : texte = "El Reino de Hyrule estaba en paz desde que Link, ultimo cavallero hyliano, haba vencido el malfico Ganon y haba recuperado la valiosa Trifuerza."; idsuiv = 229; break;
        case 229 : texte = "Nadie sabe que deseo hizo Link tocando la Trifuerza, pero tuvo como efecto de reunificar el Light World y el Dark World, y volvi a los descendientes de los 7 Hombres Sabios a la vida."; idsuiv = 230; break;
        case 230 : texte = "Despues Link devolvi a la princesa Zelda la Trifuerza y la Espada Maestra, y el pueblo se puso a creer que la paz duraria.*Pero el pueblo se equivocaba..."; idsuiv=231; break;
        case 231 : texte = "El deseo de Link a la Trifuerza igualmente tuvo lamentables efectos. Ganon y sus esbirros fuen asi resucitados y se dispusieron a atacar."; idsuiv=232; break;
        case 232 : texte = "En alguna parte del bosque de Hyrule, Link duerme sin sospechar que Ganon ya ha pasado al ataque, hasta que una voz familiar le habla en su sueo..."; break;
        case 233 : texte = "Ayuda!*Ayuda!*Soy yo! Zelda!*Te hablo por telepata."; idsuiv = 234; break;
        case 234 : texte = "Estoy prisionera en el torren del castillo! Necesito tu ayuda!*Ganon esta de vuelta, y sin duda ya ha encontrado la Trifuerza a estas horas..."; idsuiv=235; break;
        case 235 : texte = "Corre al castillo Link, eres mi nica esperanza..."; break;
        case 236 : texte = "AYUDA : Pulsa F1 para consultar la ayuda."; break;
    }
    
    
}

void Texte::affiche(SDL_Surface* gpScreen, std::string s, int a, int b) {
    for (int i = 0; i < (int)s.length(); i++) {
        afficheLettre(gpScreen, s.at(i),a,b);
        a+=6;
    }
}

void Texte::draw(SDL_Surface* gpScreen) {
    
    if (cadre) drawCadre(gpScreen);
    
    if (id==3 && texte == "Has encontrado un cuarto de corazn !!!") {
        SDL_Rect src; SDL_Rect dst;
        src.x=16*(gpJeu->getJoueur()->nbQuarts()%4);
        if(src.x==0)src.x=16*4;
        src.y=0; src.w=16; src.h=16; dst.x=160-8; dst.y=120-8+16*5;
        SDL_BlitSurface(imageCoeur, &src, gpScreen, &dst);
    }
    
    int a = x+8; int b = y+8;
    for (int i = 0; i < av; i++) {
        afficheLettre(gpScreen, texte.at(i),a,b);
        a+=6;
        if (a > x+w-16) {a=x+8; b+=16;}
    }
    
    if(SDL_GetTicks() > lastAnimTime + vitesse && def && av < (int)texte.length()) {
        lastAnimTime = SDL_GetTicks();
        do av++;
        while (av < (int)texte.length() && texte.at(av-1) == ' ');
        if (texte.at(av-1) != ' ') gpJeu->getAudio()->playSound(0,1);
    }
}

bool Texte::isFinished() {return (av==(int)texte.length());}

int Texte::getId() {return id;}

void Texte::changeId(int i) {
    id=i; idsuiv=0; buffer="";
    chercheText();
    decoupeText();
    if (av>(int)texte.length()) av=(int)texte.length();
}

void Texte::drawCadre(SDL_Surface* gpScreen) {
    SDL_Rect src;
    SDL_Rect dst;
    
    src.w=8; src.h=8; src.x = 103; src.y = 100; dst.x = x; dst.y = y;
    SDL_BlitSurface(imageFont, &src, gpScreen, &dst);
    
    src.x = 112;
    for (int i = 8; i < w-8; i+=16) {
        dst.x = x+i; src.w=16;
        while (dst.x + src.w > x+w && src.w>0) src.w--;
        if (src.w>0) SDL_BlitSurface(imageFont, &src, gpScreen, &dst);
    }
    
    src.w=8; src.x = 129; dst.x = x+w-8;
    SDL_BlitSurface(imageFont, &src, gpScreen, &dst);
    
    src.y = 109; src.w=8;
    for (int j = 8; j < h-8; j+=16) {
        dst.y = y + j;
        src.x = 103; dst.x = x; src.h=16;
        while (dst.y + src.h > y+h && src.h>0) src.h--;
        if (src.h>0) SDL_BlitSurface(imageFont, &src, gpScreen, &dst);
    
        src.x = 129; dst.x = x+w-8;
        if (src.h>0)SDL_BlitSurface(imageFont, &src, gpScreen, &dst);
    }
    
    src.h=8; src.x = 103; src.y = 126; dst.x = x; dst.y = y+h-8;
    SDL_BlitSurface(imageFont, &src, gpScreen, &dst);
    
    src.x = 112;
    for (int i = 8; i < w-8; i+=16) {
        dst.x = x+i; src.w=16;
        while (dst.x + src.w > x+w && src.w>0) src.w--;
        if (src.w>0) SDL_BlitSurface(imageFont, &src, gpScreen, &dst);
    }
    
    src.w=8; src.x = 129; dst.x = x+w-8;
    SDL_BlitSurface(imageFont, &src, gpScreen, &dst);
}

void Texte::setTexte(int idTxt, int vx, int vy, int vw, int vh, bool cadr, bool defil, int vit) {
    if (idTxt == 0) return;
    id = idTxt; 
    idsuiv = 0;
    buffer = "";
    chercheText();
    
    x = vx; y = vy; w = vw; h = vh;
    decoupeText();
        
    def=defil;
    if (def) av = 0;
    else av = texte.length();
    
    cadre = cadr;
    
    vitesse = vit;
}

void Texte::decoupeText() {
    //compte le nombre de caractres possibles et largeur et en hauteur
    int nbcol = (w-16)/6 -1;
    int nblig = (h-16)/16;
    int tailleMax = nbcol * nblig;
    int taille;
    
    //parcours du texte  afficher;  chaque dbut de mot, 
    //vrifie que le mot peut tenir sur la ligne
    for (int i = 0; i < (int)texte.length(); i++) {
        
        //supprime les espaces isols en dbut de ligne
        if (texte.at(i)==' ' && texte.at(i+1)!=' ' && i%nbcol == 0) texte.erase(i,1);
        //recherche du dbut du prochain mot
        while(texte.at(i)==' ' && i < (int)texte.length()-1) i++;
        
        //saute une ligne si trouve une toile
        if (texte.at(i)=='*') {
            texte.erase(i,1);//replace(i, 1, " ");
            int nb = (nbcol)-(i%(nbcol));
            for (int j = 0; j < nb; j++) texte.insert(i," ");
            continue;
        }
        
        //si le mot dpasse
        taille = tailleMot(i);
        if ((i%nbcol)+taille>nbcol) {
            if  (i < tailleMax) {
                //si le mot ne tient pas sur une ligne, on le coupe avec des tirets
                if (taille>nbcol) {
                    texte.insert(((i/nbcol)+1)*nbcol-1,"--");
                    i = 1+((i/nbcol)+1)*nbcol;
                }
                //sinon, on ajoute des espaces pour faire commencer le mot  la ligne
                else while((i%nbcol) != 0) {texte.insert(i," "); i++;}
            }
        }
        
    }
    
    // si le texte est trop grand, on le coupe en deux
    if ((int)texte.length() > tailleMax) {
        buffer = texte.substr(tailleMax);
        texte = texte.substr(0, tailleMax);
    }
}

int Texte::tailleMot(int deb) {
    int i = deb;
    int total = 0;
    while (texte.at(i)!=' ') {total++; i++; if (i >= (int)texte.length()) return total;}
    return total;
}

void Texte::afficheLettre(SDL_Surface* gpScreen, char c, int vx, int vy) {
    SDL_Rect src;
    SDL_Rect dst;
    
    int val = (int)c;
    
    dst.x=vx; dst.y=vy;
    src.h=16;src.w=8;
    
    if(val==32) return;
    
    // es
    // 
    if(val==-15) {src.x=164;src.y=68;}
    // 
    if(val==-13) {src.x=164;src.y=103;}
    // 
    if(val==-19) {src.x=164;src.y=52;}
    // 
    if(val==-31) {src.x=164;src.y=84;}
    // 
    if(val==-6) {src.x=164;src.y=151;}
    
    
    // /
    if(val==47) {src.x=52;src.y=151;}
    
    // @ hylien
    if(val==64) {src.x=4;src.y=151;}
            
    // + hylien
    if(val==43) {src.x=20;src.y=151;}
            
    // = hylien
    if(val==61) {src.x=36;src.y=151;}
            
    //minuscules a-z
    if(val>=97 && val<=122) {src.x=4+16*((val-97)%10); src.y=52+16*((val-97)/10);}
            
    //majuscules A-Z
    if(val>=65 && val<=90) {src.x=6+16*((val-65)%10); src.y=2+16*((val-65)/10);}   
    // 
    if(val==-25) {src.x=148;src.y=34;}
    // 
    if(val==-23) {src.x=100;src.y=84;}
    // 
    if(val==-22) {src.x=116;src.y=84;}
    // 
    if(val==-24) {src.x=132;src.y=84;}
    // 
    if(val==-21) {src.x=132;src.y=151;}
    // 
    if(val==-32) {src.x=148;src.y=84;}
    // 
    if(val==-30) {src.x=148;src.y=103;}
    // 
    if(val==-28) {src.x=148;src.y=135;}
    // 
    if(val==-18) {src.x=84;src.y=119;}
    // 
    if(val==-17) {src.x=116;src.y=151;}
    // 
    if(val==-5) {src.x=84;src.y=103;}
    // 
    if(val==-7) {src.x=148;src.y=151;}
    // 
    if(val==-4) {src.x=116;src.y=135;}
    // 
    if(val==-10) {src.x=132;src.y=135;}
    // 
    if(val==-12) {src.x=148;src.y=119;}
            
    //ponctuation
    // -
    if(val==45) {src.x=102;src.y=34;}
    // .
    if(val==46) {src.x=118;src.y=34;}
    // ,
    if(val==44) {src.x=134;src.y=34;}
    // !
    if(val==33) {src.x=3;src.y=135;}
    // ?
    if(val==63) {src.x=19;src.y=135;}
    // (
    if(val==40) {src.x=35;src.y=135;}
    // )
    if(val==41) {src.x=51;src.y=135;}            
    // ' ( avec @ )
    if(val==39) {src.x=67;src.y=135;}
    // :
    if(val==58) {src.x=83;src.y=135;}
    // ... ( avec % )
    if(val==37) {src.x=101;src.y=135;}
    // >
    if(val==62) {src.x=100;src.y=151;}
    // <
    if(val==60) {src.x=84;src.y=151;}
            
    //chiffres            
    if(val>=48 && val<=57) {src.x=3+16*((val-48)%5); src.y=103+16*((val-48)/5);}
    
    SDL_BlitSurface(imageFont, &src, gpScreen, &dst);
}

bool Texte::hasNext() {
    return (buffer != "" || idsuiv > 0);
}

bool Texte::suite() {
    if (av < (int)texte.length()) {
        av = texte.length();
        return true;
    }
    if (!hasNext()) {
        gpJeu->getAudio()->playSound(18);
        return gpJeu->finTexte(id);
    }
    if (buffer != "") {
        texte = buffer;
        buffer = "";
    }
    else {
        id = idsuiv;
        idsuiv = 0;
        chercheText();
    }
    decoupeText();
    if (def) av = 0;
    else av = texte.length();
    gpJeu->getAudio()->playSound(17);
    return true;
}
